import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class MauseSchwanz extends JFrame
             implements MouseMotionListener {

    // Hilfsklasse für die Speicherung der Linien
    class Linie {
        int xAnf=0,yAnf=0;
        int xEnde=0,yEnde=0;
    }

    private final int MAXPOS = 30; // wie viele Linien?
    private int indexPos = 0;      // aktuelle Position
    private Linie linie[];         // die letzten Linien
    private int letztX, letztY;    // letzte Position

    // Konstruktor
    public MauseSchwanz() {
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        // Linienspeicher einrichten
        linie = new Linie[MAXPOS];
        for (int i=0; i<MAXPOS; i++) {
            linie[i] = new Linie();
        }
        // Den Listener aktivieren
        addMouseMotionListener(this);
    }

    public void mouseDragged(MouseEvent ev) { }

    // Die Maus wurde bewegt und ruft diese Methode
    public void mouseMoved(MouseEvent ev) {
        // Position speichern
        linie[indexPos].xEnde = letztX;
        linie[indexPos].yEnde = letztY;
        linie[indexPos].xAnf = letztX = ev.getX();
        linie[indexPos].yAnf = letztY = ev.getY();
        // Zeiger im Speicher vorrücken
        indexPos++;
        if (indexPos>=MAXPOS) {
            indexPos = 0;
        }
        repaint(); // Erzwinge Neuzeichnen
    }

    public void paint(Graphics g) {
        // Bildschirm freimachen
        g.clearRect(0, 0, getWidth(), getHeight());
        // Die älteren Linien zeichnen
        for (int i=indexPos; i<MAXPOS; i++) {
            g.drawLine(linie[i].xAnf, linie[i].yAnf,
                       linie[i].xEnde, linie[i].yEnde);
        }
        // Die neuesten Linien zeichnen
        for (int i=0; i<indexPos; i++) {
            g.drawLine(linie[i].xAnf, linie[i].yAnf,
                       linie[i].xEnde, linie[i].yEnde);
        }
    }

    public static void main(String[] args) {
        MauseSchwanz fenster = new MauseSchwanz();
        fenster.setTitle("Mausschlängeln mit Java");
        fenster.setSize(400, 300);
        fenster.setVisible(true);
    }
}
