import java.io.File;
import java.util.Optional;

import javafx.application.Application;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.scene.Scene;
import javafx.scene.control.Alert;
import javafx.scene.control.Alert.AlertType;
import javafx.scene.control.ButtonBar.ButtonData;
import javafx.scene.control.ButtonType;
import javafx.scene.control.Menu;
import javafx.scene.control.MenuBar;
import javafx.scene.control.MenuItem;
import javafx.scene.control.TextInputDialog;
import javafx.scene.layout.BorderPane;
import javafx.stage.DirectoryChooser;
import javafx.stage.FileChooser;
import javafx.stage.Stage;

public class FxMenueDialoge extends Application
implements EventHandler<ActionEvent> {
	public static void main(String[] args) {
		launch(args);
	}

	MenuItem mnOpen = new MenuItem("Öffnen");
	MenuItem mnSave = new MenuItem("Speichern");
	MenuItem mnDir = new MenuItem("Verzeichnis");
	MenuItem mnEnde = new MenuItem("Ende");
	MenuItem mnNote = new MenuItem("Meldung");
	MenuItem mnInput = new MenuItem("Eingabe");
	MenuItem mnJaNein = new MenuItem("Ja/Nein");
	Stage stage = null;

	@Override
	public void start(Stage primaryStage) throws Exception {
		stage = primaryStage;
		MenuBar menuBar = new MenuBar();
		Menu menuDatei = new Menu("Datei");
		Menu menuEdit = new Menu("Bearbeiten");
		Menu menuView = new Menu("Ansicht");
		menuBar.getMenus().addAll(
				menuDatei, menuEdit, menuView);
		BorderPane borderpane = new BorderPane();
		borderpane.setTop(menuBar);
		menuDatei.getItems().addAll(
				mnOpen, mnSave, mnDir, mnEnde);
		mnOpen.setOnAction(this);
		mnSave.setOnAction(this);
		mnDir.setOnAction(this);
		mnEnde.setOnAction(this);
		menuView.getItems().addAll(
				mnNote, mnInput, mnJaNein);
		mnJaNein.setOnAction(this);
		mnNote.setOnAction(this);
		mnInput.setOnAction(this);
		Scene scene = new Scene(borderpane, 400, 300);
		stage.setScene(scene);
		stage.show();
	}

	@Override
	public void handle(ActionEvent event) {
		if (event.getSource() == mnEnde) {
			System.exit(0);
		} else if (event.getSource() == mnOpen) {
			FileChooser fileChooser = new FileChooser();
			File file = fileChooser.showOpenDialog(stage);
			if (file != null) {
				System.out.println(file.getPath());
			}
		} else if (event.getSource() == mnSave) {
			FileChooser fileChooser = new FileChooser();
			fileChooser.setTitle("Speichern der Datei");
			File file = fileChooser.showSaveDialog(stage);
			if (file != null) {
				System.out.println(file.getPath());
			}
		} else if (event.getSource() == mnDir) {
			DirectoryChooser dirChooser
			= new DirectoryChooser();
			File selDir = dirChooser.showDialog(stage);
			if (selDir != null) {
				System.out.println(selDir.getPath());
			}
		} else if (event.getSource() == mnNote) {
			Alert alert = new Alert(AlertType.INFORMATION);
			alert.setTitle("Titelzeile");
			alert.setHeaderText(
					"Dies ist eine Information!");
			alert.setContentText(
					"Ich habe da etwas zum Drücken!");
			alert.showAndWait().ifPresent(rs -> {
				if (rs == ButtonType.OK) {
					System.out.println("Pressed OK.");
				}
			});
		} else if (event.getSource() == mnInput) {
			TextInputDialog dialog
			= new TextInputDialog("Vorgabe");
			dialog.setTitle("Eingabedialog");
			dialog.setHeaderText("Bitte eingeben!");
			dialog.setContentText("Wie heißen Sie?");
			Optional<String> result = dialog.showAndWait();
			if (result.isPresent()) {
				System.out.println("Dein Name: "
						+ result.get());
			}
		} else if (event.getSource() == mnJaNein) {
			Alert alert = new Alert(AlertType.CONFIRMATION);
			alert.setTitle("Bestätigung");
			alert.setHeaderText("Freidefinierte Buttons");
			alert.setContentText("War das klug?");
			ButtonType btJa = new ButtonType("Ja");
			ButtonType btNein = new ButtonType("Nein");
			ButtonType btEgal = new ButtonType("Egal");
			ButtonType btAbbruch = new ButtonType(
					"Abbrechen", ButtonData.CANCEL_CLOSE);
			alert.getButtonTypes().setAll(
					btJa, btNein, btEgal, btAbbruch);
			Optional<ButtonType> result
			= alert.showAndWait();
			if (result.get() == btJa) {
				System.out.print("Ja");
			} else if (result.get() == btNein) {
				System.out.print("Nein");
			} else if (result.get() == btEgal) {
				System.out.print("Egal");
			} else {
				System.out.print("Weg hier!");
			}
			System.out.println(result.get().getText());
		}
	}
}
