import javafx.application.Application;
import javafx.beans.value.ChangeListener;
import javafx.beans.value.ObservableValue;
import javafx.geometry.NodeOrientation;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.ListView;
import javafx.scene.control.Tab;
import javafx.scene.control.TabPane;
import javafx.scene.control.TabPane.TabClosingPolicy;
import javafx.scene.control.TextField;
import javafx.scene.layout.BorderPane;
import javafx.scene.layout.FlowPane;
import javafx.scene.layout.GridPane;
import javafx.stage.Stage;

public class FxTabPane  extends Application {

	public static void main(String[] args) {
		launch(args);
	}

	@Override
	public void start(Stage stage) throws Exception {
		TabPane tabPane = new TabPane();
		tabPane.setTabClosingPolicy(TabClosingPolicy.UNAVAILABLE);
		Tab tabGast = new Tab("Gast");
		Tab tabWohnung = new Tab("Zimmer");
		Tab tabBelegung = new Tab("Belegung");
		tabPane.getTabs().add(tabGast);
		tabPane.getTabs().add(tabWohnung);
		tabPane.getTabs().add(tabBelegung);
		tabPane.getSelectionModel().select(tabBelegung);
		// Tabs mit Dialogen füllen
		GridPane gastDialog = new GridPane();
		gastDialog.add(new Label("Name:"), 0, 1);
		gastDialog.add(new TextField(), 1, 1);
		gastDialog.add(new Label("Straße:"), 0, 2);
		gastDialog.add(new TextField(), 1, 2);
		gastDialog.add(new Label("Ort:"), 0, 3);
		gastDialog.add(new TextField(), 1, 3);
		tabGast.setContent(gastDialog);
		tabBelegung.setContent(new ListView<String>());
		// Reaktionen
		tabPane.getSelectionModel().selectedItemProperty()
		.addListener(new ChangeListener<Tab>() {
			@Override
			public void changed(
					ObservableValue<? extends Tab> observable,
					Tab oldValue, Tab newValue) {
				if (newValue == tabGast) {
					System.out.println("Gast");
					// ...
				} else if (newValue == tabBelegung) {
					System.out.println("Belegung");
					// ...
				}
			}
		});
		// TabPane in einen Border mit Schließbutton
		BorderPane border = new BorderPane(tabPane);
		FlowPane flow = new FlowPane (4, 4);
		flow.setNodeOrientation(
				NodeOrientation.RIGHT_TO_LEFT);
		flow.getChildren().add(new Button("Schließen"));
		border.setBottom(flow);
		Scene scene = new Scene(border, 400, 200);
		stage.setScene(scene);
		stage.show();
	}
}
