import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.*;

public class BMI extends JFrame implements ActionListener {
    public static void main(String[] args) {
        new BMI();
    }

    JTextField txtGroesse, txtGewicht;
    JLabel labMeldung, labBmi;

    public BMI() {
        setDefaultCloseOperation(EXIT_ON_CLOSE);
        setLayout(new GridLayout(4, 2));
        JLabel labGroesse = new JLabel("Größe (cm):");
        JLabel labGewicht = new JLabel("Gewicht (kg):");
        labMeldung = new JLabel(" ");
        labBmi = new JLabel(" ");
        txtGroesse = new JTextField();
        txtGewicht = new JTextField();
        JButton btnStart = new JButton("OK");
        btnStart.addActionListener(this); // Aktivieren!
        // Zusammenbau aller Elemente
        add(labGroesse);
        add(txtGroesse);
        add(labGewicht);
        add(txtGewicht);
        add(labBmi);
        add(btnStart);
        add(labMeldung);
        pack();
        setVisible(true);
    }

    @Override
    public void actionPerformed(ActionEvent ev) {
        if (txtGroesse.getText().length() > 0
                && txtGewicht.getText().length() > 0) {
            try {
                // Der Eingabe-String wird zur Zahl gewandelt
                int groesse =
                        Integer.parseInt(txtGroesse.getText());
                int gewicht =
                        Integer.parseInt(txtGewicht.getText());
                double bmi =
                        gewicht / (groesse*groesse/10000.0);
                // Eine Nachkommastelle reicht beim BMI
                bmi = Math.round(bmi * 10.0) / 10.0;
                labBmi.setText("BMI = " + bmi);
                if (bmi < 20.0) {
                    labMeldung.setText("Untergewicht");
                } else if (bmi <= 25.0) {
                    labMeldung.setText("Normalgewicht");
                } else if (bmi <= 30) {
                    labMeldung.setText("Übergewicht");
                } else if (bmi <= 40) {
                    labMeldung.setText("Adipositas");
                } else {
                    labMeldung.setText("Starke Adipositas");
                }
            } catch (NumberFormatException ex) {
                labMeldung.setText("Fehlerhafte Eingabe");
            }
        } else {
            labMeldung.setText("Fehlende Eingaben");
        }
    }
}
