import javax.swing.JFrame;
import javax.swing.*;
import java.awt.GridLayout;
import java.awt.event.*;

public class Menue extends JFrame implements ActionListener {
    public static void main(String[] args) {
        new Menue();
    }

    JMenuItem dateiOeffnen, dateiSpeichern,
              dateiSpeichernUnter, dateiQuit;
    JMenuItem hilfeUeber;
    JLabel labName;

    public Menue() {
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setLayout(new GridLayout(2, 1));
        add(new JLabel("Hier könnte Ihre Werbung stehen!"));
        labName = new JLabel("---nichts---");
        add(labName);

        // Das Menü wird erstellt
        JMenuBar leiste = new JMenuBar();

        JMenu datei = new JMenu("Datei");
        leiste.add(datei); // Dateimenü in die JMenuBar
        dateiOeffnen = new JMenuItem("Öffnen...");
        datei.add(dateiOeffnen); // Menüpunkt einbauen
        // Listener setzen
        dateiOeffnen.addActionListener(this);
        // Jetzt die restlichen Menüpunkte analog ...
        dateiSpeichern = new JMenuItem("Speichern");
        datei.add(dateiSpeichern);
        dateiSpeichern.addActionListener(this);
        dateiSpeichernUnter
                = new JMenuItem("Speichern unter...");
        datei.add(dateiSpeichernUnter);
        dateiSpeichernUnter.addActionListener(this);
        dateiQuit = new JMenuItem("Ende");
        datei.add(dateiQuit);
        dateiQuit.addActionListener(this);

        JMenu hilfe = new JMenu("Hilfe");
        leiste.add(hilfe);
        hilfeUeber = new JMenuItem("Über");
        hilfe.add(hilfeUeber);
        hilfeUeber.addActionListener(this);

        setJMenuBar(leiste); // Menü in den Rahmen hängen
        pack();
        setVisible(true);
    }

    @Override
    public void actionPerformed(ActionEvent ev) {
        // Auf Menüpunkte abfragen
        if (ev.getSource()==dateiOeffnen) {
            // Datei öffnen! Starte die Auswahlbox!
            JFileChooser auswahl = new JFileChooser();
            if (auswahl.showOpenDialog(this)
                    ==JFileChooser.APPROVE_OPTION) {
                labName.setText(auswahl.getSelectedFile()
                                       .getName());
            }
        } else if (ev.getSource()==dateiSpeichern) {
        } else if (ev.getSource()==dateiSpeichernUnter) {
            JFileChooser auswahl = new JFileChooser();
            if (auswahl.showSaveDialog(this)
               ==JFileChooser.APPROVE_OPTION) {
                labName.setText(auswahl.getSelectedFile()
                                       .getName());
            }
        } else if (ev.getSource()==dateiQuit) {
            // Der Anwender will nach Hause
            System.exit(0);
        } else if (ev.getSource()==hilfeUeber) {
            // Reklame!
            JOptionPane.showMessageDialog(null,"Ein Menü!");
        } else {
            // Das ist eigentlich nicht vorgesehen ...
            JOptionPane.showMessageDialog(null,"Was ist das?");
        }
    }
}
