import java.io.File;
import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;

public class VerzeichnisJTree extends JFrame {
    public static void main(String[] args) {
        new VerzeichnisJTree();
    }

    // Startverzeichnis: Hier das Benutzerverzeichnis
    final static String wurzel =
            System.getProperty("user.home");

    public VerzeichnisJTree() {
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        DefaultMutableTreeNode knoten =
                new DefaultMutableTreeNode(wurzel);
        durchsuche(new File(wurzel), knoten);
        JTree baum = new JTree(knoten);
        this.add(new JScrollPane(baum));
        this.setVisible(true);
        this.setSize(400, 300);
    }

    // Durchsuche rekursiv das Verzeichnis
    public void durchsuche(File datei,
            DefaultMutableTreeNode knoten) {
        if (datei.isDirectory()) {
            File[] eintraege = datei.listFiles();
            if (eintraege != null) {
                for (File eintrag : eintraege) {
                    // Ein Knoten für den Eintrag
                    DefaultMutableTreeNode neuKnoten =
                            new DefaultMutableTreeNode(
                                    eintrag.getName());
                    knoten.add(neuKnoten);
                    // Verzeichnis? Auch durchsuchen!
                    if (eintrag.isDirectory()) {
                        durchsuche(eintrag, neuKnoten);
                    }
                }
            }
        }
    }
}
