import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.ImageIcon;
import javax.swing.JPanel;

public class BermudaPanel extends JPanel implements MouseListener, ActionListener {

    Spielfeld spiel = new Spielfeld();
    Image leer, schiff, ziffer[];
    boolean spielEnde = false;
    String statusStr = "                ";
    int distanz = 32;
    BermudaFrame frame;

    public BermudaPanel(BermudaFrame frame) {
        this.frame = frame;
        addMouseListener(this); // Fange Mausereignisse
        leer = new ImageIcon(getClass().getResource(
                "image/leer.png")).getImage();
        schiff = new ImageIcon(getClass().getResource(
                "image/schiff.png")).getImage();
        ziffer = new Image[9];
        for (int i = 0; i < 9; i++) {
            ziffer[i] = new ImageIcon(getClass().
                    getResource("image/mark"+i+".png")).
                    getImage();
        }
        distanz = new ImageIcon(getClass().getResource(
                "image/schiff.png")).getIconWidth();
    }

    @Override
    public void paint(Graphics g) {
        for (int i = 0; i < Spielfeld.MAXX; i++) {
            for (int j = 0; j < Spielfeld.MAXY; j++) {
                Position pos = new Position(i, j);
                char c = spiel.get(pos);
                Image img = null;
                if (c >= '0' && c <= '8') {
                    img = ziffer[c - '0'];
                } else if (c == Flotte.SCHIFF) {
                    img = schiff;
                } else {
                    img = leer;
                }
                g.drawImage(img, i * distanz,
                                 j * distanz, this);
            }
        }
    }
       
    // Das Panel meldet seine Platzbedürfnisse an
    @Override
    public Dimension getPreferredSize() {
        return new Dimension((Spielfeld.MAXX) * distanz,
                (Spielfeld.MAXY) * distanz);
    }

    // ---------- Methoden des MouseListeners ------------
    @Override
    public void mouseClicked(MouseEvent me) {
        Position pos = new Position(me.getX()/distanz,
                                    me.getY()/distanz);
        if (spiel.istImSpielfeld(pos)) {
            char ergebnis = spiel.suche(pos);
            spiel.set(pos, ergebnis);
            if (spiel.alleSchiffeGefunden()) {
                frame.lblMeldung.setText("Spiel gewonnen!");
            }
        }
        repaint();
    }

    public void mouseReleased(MouseEvent me) {}
    public void mousePressed(MouseEvent me) {}
    public void mouseEntered(MouseEvent me) {}
    public void mouseExited(MouseEvent me) {}

    // --- Methode des ActionListeners (Button) ---
    @Override
    public void actionPerformed(ActionEvent e) {
        spiel = new Spielfeld();
        frame.lblMeldung.setText("Suche nach Schiffen");
        repaint();
    }
}
