package application;

import javafx.event.EventHandler;
import javafx.scene.canvas.Canvas;
import javafx.scene.canvas.GraphicsContext;
import javafx.scene.control.Label;
import javafx.scene.image.Image;
import javafx.scene.input.MouseEvent;

public class BermudaCanvas extends Canvas implements EventHandler<MouseEvent> {

	private Spielfeld spiel;
	private Image leer, ziffer[];
	private Image schiff;
	int distanz;
	private Label lblMeldung;

	private void zeigePos(char c, Position pos) {
		GraphicsContext gc = this.getGraphicsContext2D();
		Image img = null;
		if (c >= '0' && c <= '8') {
			img = ziffer[c - '0'];
		} else if (c == Flotte.SCHIFF) {
			img = schiff;
		} else {
			img = leer;
		}
		gc.drawImage(img, pos.getX() * distanz, pos.getY() * distanz);		
	}
	
	private void zeigeFeld() {
		for (int i = 0; i < Spielfeld.MAXX; i++) {
			for (int j = 0; j < Spielfeld.MAXY; j++) {
				Position pos = new Position(i, j);
				char c = spiel.get(pos);
				zeigePos(c, pos);
			}
		}		
	}
	
	private void ermittleDistanz(Image img) {
		int distImg = (int) img.getWidth();
		if (distImg>distanz) {
			distanz = distImg;
		}		
	}
	
	public BermudaCanvas(Label frameLabel) {
		lblMeldung = frameLabel;
		this.spiel = new Spielfeld();
		this.setOnMousePressed(this);
		leer = new Image("image/leer.png");
		schiff = new Image("image/schiff.png");
		ermittleDistanz(leer);
		ermittleDistanz(schiff);
		ziffer = new Image[9];
		for (int i = 0; i < 9; i++) {
			ziffer[i] = new Image("image/mark" + i + ".png");
			ermittleDistanz(ziffer[i]);
		}
		this.setWidth((Spielfeld.MAXX) * distanz);
		this.setHeight((Spielfeld.MAXY) * distanz);
		zeigeFeld();
	}
	
	@Override
	public void handle(MouseEvent event) {
		int x = (int) event.getX();
		int y = (int) event.getY();
		Position pos = new Position(x/distanz, y/distanz);
		if (spiel.istImSpielfeld(pos)) {
			char ergebnis = spiel.suche(pos);
			zeigePos(ergebnis, pos);
			spiel.set(pos, ergebnis);
			if (spiel.alleSchiffeGefunden()) {
				lblMeldung.setText("Spiel gewonnen!");
			}
		}
	}

	public void neuesSpiel() {
		lblMeldung.setText("Bermuda");
		spiel = new Spielfeld();
		zeigeFeld();		
	}
}
