package de.willemer.andybmi;

import android.content.Intent;
import android.support.v7.app.ActionBarActivity;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnFocusChangeListener;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.Spinner;
import android.widget.TextView;

public class BmiActivity extends AppCompatActivity
                        implements View.OnClickListener,
                        AdapterView.OnItemSelectedListener, OnFocusChangeListener, RadioGroup.OnCheckedChangeListener {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_bmi);
        Button button = (Button) findViewById(R.id.btRechne);
        button.setOnClickListener(this);
        RadioButton rbGeschlecht = (RadioButton) findViewById(R.id.rbMaennlich);
        rbGeschlecht.setChecked(true);
        RadioGroup radioGroup = (RadioGroup) findViewById(R.id.rgGeschlecht);
        radioGroup.setOnCheckedChangeListener(this);
        //radioGroup.setOnFocusChangeListener(this);
        EditText edGroesse = (EditText) findViewById(R.id.edGroesse);
        edGroesse.setOnFocusChangeListener(this);
        EditText edGewicht = (EditText) findViewById(R.id.edGewicht);
        edGewicht.setOnFocusChangeListener(this);
        Spinner spAge= (Spinner) findViewById(R.id.spAge);
        ArrayAdapter<CharSequence> adapter = ArrayAdapter.createFromResource(this,
                R.array.strAges, android.R.layout.simple_spinner_item);
        adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spAge.setAdapter(adapter);
        spAge.setOnItemSelectedListener(this);
        onClick(button);
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.menu_bmi, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        int id = item.getItemId();
        if (id == R.id.action_settings) {
            Intent intent = new Intent(this, InfoActivity.class);
            startActivity(intent);
            return true;
        }
        return super.onOptionsItemSelected(item);
    }

    private double calcBmi() {
        RadioButton rbMaennlich = (RadioButton) findViewById(R.id.rbMaennlich);
        boolean maennlich = rbMaennlich.isChecked();
        EditText edGroesse = (EditText) findViewById(R.id.edGroesse);
        String strGroesse = String.valueOf(edGroesse.getText());
        double groesse = Double.parseDouble(strGroesse);
        EditText edGewicht = (EditText) findViewById(R.id.edGewicht);
        String strGewicht = String.valueOf(edGewicht.getText());
        double gewicht = Double.parseDouble(strGewicht);
        Spinner spAge = (Spinner) findViewById(R.id.spAge);
        long alter = spAge.getSelectedItemId();
        if (alter<0) alter = 0;
        if (groesse==0) return 0;
        double bmi = gewicht / (groesse*groesse / 10000.0);
        bmi = Math.round(bmi * 10.0) / 10.0;
        if (!maennlich) bmi++;
        bmi -= alter;
        return bmi;
    }

    public void showBmi(double bmi) {
        TextView lbBmi = (TextView) findViewById(R.id.lbBmi);
        if (bmi<20.0) {
            lbBmi.setText(getString(R.string.Untergewicht));
        } else if (bmi<=25) {
            lbBmi.setText(getString(R.string.Normalgewicht));
        } else if (bmi<=30) {
            lbBmi.setText(getString(R.string.Uebergewicht));
        } else if (bmi<=40) {
            lbBmi.setText(getString(R.string.Antipositas));
        } else {
            lbBmi.setText(getString(R.string.StarkeAntipositas));
        }
    }

    @Override
    public void onClick(View v) {
        double bmi = calcBmi();
        showBmi(bmi);
    }

    @Override
    public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
        double bmi = calcBmi();
        showBmi(bmi);
    }

    @Override
    public void onNothingSelected(AdapterView<?> parent) {
        parent.setSelection(0);
    }

    @Override
    public void onFocusChange(View v, boolean hasFocus) {
        double bmi = calcBmi();
        showBmi(bmi);
    }

    @Override
    public void onCheckedChanged(RadioGroup group, int checkedId) {
        double bmi = calcBmi();
        showBmi(bmi);
    }
}
