import java.io.File;
import java.io.IOException;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

public class ReadVokXml {
	public static void main(String[] argv) {
		try {
			DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
			DocumentBuilder builder = factory.newDocumentBuilder();
			Document document = builder.parse(new File("vokabel.xml"));
			NodeList nodeList = document.getElementsByTagName("vokabel");
			for (int i = 0; i < nodeList.getLength(); i++) {
				Node nodeChild = nodeList.item(i);
				Vokabel vokabel = new Vokabel();
				leseVokabel(nodeChild, vokabel);
				System.out.println("Vokabel: " + vokabel);
			}
		} catch (SAXParseException spe) {
			System.out.println("Parse-Fehler Zeile: " + spe.getLineNumber() + ", uri " + spe.getSystemId());
		} catch (SAXException sxe) {
			sxe.printStackTrace();
		} catch (ParserConfigurationException pce) {
			pce.printStackTrace();
		} catch (IOException ioe) {
			ioe.printStackTrace();
		}
	}

	static void leseVokabel(Node node, Vokabel vokabel) {
		NodeList nodeList = node.getChildNodes();
		for (int i = 0; i < nodeList.getLength(); i++) {
			Node childNode = nodeList.item(i);
			String str = childNode.getTextContent();
			str = str.trim();
			if (!str.isEmpty()) {
				if (childNode.getNodeName().equals("frage")) {
					vokabel.frage = str;
				} else if (childNode.getNodeName().equals("antwort")) {
					vokabel.antwort = str;
				} else if (childNode.getNodeName().equals("zuletzt")) {
					leseDatum(childNode, vokabel.zuletzt);
				}
			}
		}
		NamedNodeMap attribs = node.getAttributes();
		for (int i = 0; i < attribs.getLength(); i++) {
			Node attChild = attribs.item(i);
			String name = attChild.getNodeName();
			String value = attChild.getNodeValue();
			if (name.equals("fachnr")) {
				vokabel.fachnr = Integer.parseInt(value);
			} else if (name.equals("bekannt")) {
				vokabel.bekannt = Integer.parseInt(value);
			} else if (name.equals("unbekannt")) {
				vokabel.unbekannt = Integer.parseInt(value);
			}
		}
	}

	static void leseDatum(Node node, Datum datum) {
		NodeList datumList = node.getChildNodes();
		for (int i = 0; i < datumList.getLength(); i++) {
			Node datumChild = datumList.item(i);
			String wert = datumChild.getTextContent();
			wert = wert.trim();
			String nodeName = datumChild.getNodeName();
			if (nodeName.equals("tag")) {
				datum.tag = Integer.parseInt(wert);
			} else if (nodeName.equals("monat")) {
				datum.monat = Integer.parseInt(wert);
			} else if (nodeName.equals("jahr")) {
				datum.jahr = Integer.parseInt(wert);
			}
		}
	}
}
