import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.util.ArrayList;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.TransformerFactoryConfigurationError;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class WriteVokXml {

	static Vokabel createVok(String frage, String antwort) {
		Vokabel vok = new Vokabel();
		vok.frage = frage;
		vok.antwort = antwort;
		vok.zuletzt.jahr = 2018;
		return vok;
	}
	
    public static void main( String[] argv ) {
        ArrayList<Vokabel> vokabeln = new ArrayList<Vokabel>();
        vokabeln.add(createVok("Uhr", "clock"));
        vokabeln.add(createVok("Katze", "Igitt"));
        try {
            DocumentBuilderFactory factory
                    = DocumentBuilderFactory.newInstance();
            DocumentBuilder builder;
            builder = factory.newDocumentBuilder();
            Document doc = builder.newDocument();
            Element root = doc.createElement("vokabelkasten");
            for (Vokabel vokabel : vokabeln) {
            	Element element = createVokabel(doc, vokabel);
                root.appendChild(element.cloneNode(true));
            }
            doc.appendChild(root);
            // schreibe Document in eine Datei
            Transformer transformer = TransformerFactory.newInstance()
                                             .newTransformer();
            DOMSource source = new DOMSource(doc);
            FileOutputStream os = new FileOutputStream(new File("ausgabe.xml"));
            StreamResult result = new StreamResult(os);
            transformer.setOutputProperty(OutputKeys.INDENT, "yes") ;
            transformer.setOutputProperty(OutputKeys.ENCODING, "UTF-8") ;
            transformer.transform(source, result);
        } catch (TransformerConfigurationException e) {
            e.printStackTrace();
        } catch (TransformerFactoryConfigurationError e) {
            e.printStackTrace();
        } catch (TransformerException e) {
            e.printStackTrace();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (ParserConfigurationException e) {
            e.printStackTrace();
        }
    }

	static Element createVokabel(Document doc, Vokabel vokabel) {
		Element frage = doc.createElement("frage");
		frage.setTextContent(vokabel.frage);
		Element antwort = doc.createElement("antwort");
		antwort.setTextContent(vokabel.antwort);
		Element element = doc.createElement("vokabel");
		element.appendChild(frage.cloneNode(true));
		element.appendChild(antwort.cloneNode(true));
		element.setAttribute("fachnr", "" + vokabel.fachnr);
		element.setAttribute("bekannt", "" + vokabel.bekannt);
		element.setAttribute("unbekannt", ""+vokabel.unbekannt);
		Element zuletzt = createDatum(doc, vokabel.zuletzt);
		element.appendChild(zuletzt.cloneNode(true));
		return element;
	}

	static Element createDatum(Document doc, Datum datum) {
		Element zuletzt = doc.createElement("zuletzt");
		Element tag = doc.createElement("tag");
		tag.setTextContent("" + datum.tag);
		zuletzt.appendChild(tag.cloneNode(true));
		Element monat = doc.createElement("monat");
		monat.setTextContent("" + datum.monat);
		zuletzt.appendChild(monat.cloneNode(true));
		Element jahr = doc.createElement("jahr");
		jahr.setTextContent("" + datum.jahr);
		zuletzt.appendChild(jahr.cloneNode(true));
		return zuletzt;
	}

}
