package rmi;

import java.net.MalformedURLException;
import java.rmi.Naming;
import java.rmi.RemoteException;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;
import java.rmi.server.UnicastRemoteObject;

public class MeinServer extends UnicastRemoteObject
						implements ServerInterface {

	MeinServer() throws RemoteException {
		super();
	}

	public static void main(String[] args) {
		try {
			LocateRegistry.createRegistry(
					Registry.REGISTRY_PORT);
			Naming.rebind("MeinServer", new MeinServer());
		} catch (MalformedURLException e) {
			e.printStackTrace();
		} catch (RemoteException e) {
			e.printStackTrace();
		}
	}

	@Override
	public int gibZahl() throws RemoteException {
		return 42;
	}

	@Override
	public String bitteMeldeMich(String name) throws RemoteException {
		return "Hallo "+name;
	}

	@Override
	public Person lieferePerson() throws RemoteException {
		Person person = new Person();
		person.name ="Alexander";
		person.setGebJahr(1996);
		return person;
	}

	@Override
	public Person altere(Person person) throws RemoteException {
		int jahr = person.getGebJahr();
		person.setGebJahr(jahr+1);
		return person;
	}
}
