package buchung;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.sql.Date;

public class BuchDao {

	private String host = "localhost";
	private String dbName = "fewo";
	private String tableName = "buchung";
	private String user = "fewoadmin";
	private String password = "geheim";

	static private BuchDao instance = null;

	static public BuchDao getInstance() {
		if (instance == null) {
			instance = new BuchDao();
		}
		return instance;
	}

	private BuchDao() {
		try {
			Class.forName("org.postgresql.Driver");
		} catch (ClassNotFoundException e) {
			System.out.println("Kein Treiber");
			e.printStackTrace();
		}
	}

	private Connection connect() throws SQLException {
		Connection dbConnect = DriverManager.getConnection("jdbc:postgresql://" + host + "/" + dbName, user, password);
		return dbConnect;
	}

	public long addBuchung(Buchung buchung) {
		long id = -1L;
		try {
			Connection connection = this.connect();
			String[] returnIds = { "id" };
			PreparedStatement statement = connection.prepareStatement(
					"insert into " + tableName + " (von, bis, gastid, wohnung) " 
					+ "VALUES (?,?,?,?)", returnIds);
			statement.setDate(1, new Date(buchung.getVon().getTime()));
			statement.setDate(2, new Date(buchung.getBis().getTime()));
			statement.setLong(3, buchung.getGastid());
			statement.setString(4, buchung.getWohnung());
			statement.executeUpdate();
			// Die ID des eingefügten Satzes zurückholen
			ResultSet generatedKeys = statement.getGeneratedKeys();
			if (generatedKeys.next()) {
				id = generatedKeys.getLong(1);
				buchung.setId(id);
			}
			statement.close();
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return id;
	}

	public ArrayList<Buchung> getBuchung() {
		ArrayList<Buchung> liste = new ArrayList<>();
		try {
			Connection connection = this.connect();
			Statement statement = connection.createStatement();
			String select = "SELECT id, von, bis, gastid, wohnung" + " FROM " + tableName;
			ResultSet ergebnis = statement.executeQuery(select);
			while (ergebnis.next()) {
				Buchung buchung = new Buchung();
				buchung.setId(ergebnis.getLong("id"));
				buchung.setVon(ergebnis.getDate("von"));
				buchung.setBis(ergebnis.getDate("bis"));
				buchung.setGastid(ergebnis.getLong("gastid"));
				buchung.setWohnung(ergebnis.getString("wohnung"));
				liste.add(buchung);
			}
			ergebnis.close(); // Ergebnismenge schliessen
			statement.close();
		} catch (SQLException e) {
		}
		return liste;
	}
}
