package buchung;

import java.net.URI;
import java.util.List;

import javax.ws.rs.Consumes;
import javax.ws.rs.GET;
import javax.ws.rs.PUT;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.UriInfo;

@Path("buchung")
public class BuchServer {

	@GET
	@Path("all")
	@Produces(MediaType.APPLICATION_XML)
	public List<Buchung> getAllXml() {
		System.out.println("getAll");
		List<Buchung> list = BuchDao.getInstance().getBuchung();
		return list;
	}

	@Context
	UriInfo uriInfo;
	
	@PUT
	@Consumes(MediaType.APPLICATION_XML)
	@Produces(MediaType.APPLICATION_XML)
	public Response putBuchung(Buchung buchung) {
		Long pos = BuchDao.getInstance().addBuchung(buchung);
		if (pos < 0) {
			throw new WebApplicationException(Response.status(400)
					.entity("Not created.").build());
		}
		buchung.setId(pos); // uebernehme die erzeugte ID
		URI uri = uriInfo.getAbsolutePathBuilder().path(Long.toString(pos)).build();
        return Response.created(uri).entity(buchung).build();
	}
}
