package gast;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;

public class GastDao {

	private String host = "localhost";
	private String dbName = "fewo";
	private String tableName = "gast";
	private String user = "fewoadmin";
	private String password = "geheim";

	static private GastDao instance = null;

	static public GastDao getInstance() {
		if (instance == null) {
			instance = new GastDao();
		}
		return instance;
	}

	private GastDao() {
		try {
			Class.forName("org.postgresql.Driver");
		} catch (ClassNotFoundException e) {
			System.out.println("Kein Treiber");
			e.printStackTrace();
		}
	}

	private Connection connect() throws SQLException {
		// Verbindung mit automatischer Erzeugung der DB
		Connection dbConnect = DriverManager.getConnection("jdbc:postgresql://" + host + "/" + dbName, user, password);
		return dbConnect;
	}

	public long addGast(Gast gast) {
		long id = -1L;
		try {
			Connection connection = this.connect();
			String[] returnIds = { "id" };
			PreparedStatement statement = connection.prepareStatement(
					"insert into " + tableName + " (name, adresse, ort, email, telefon) " + "VALUES (?,?,?,?,?)",
					returnIds);
			statement.setString(1, gast.getName());
			statement.setString(2, gast.getAdresse());
			statement.setString(3, gast.getOrt());
			statement.setString(4, gast.getEmail());
			statement.setString(5, gast.getTelefon());
			statement.executeUpdate();
			// Die ID des eingefügten Satzes zurückholen
			ResultSet generatedKeys = statement.getGeneratedKeys();
			if (generatedKeys.next()) {
				id = generatedKeys.getLong(1);
				gast.setId(id);
			}
			statement.close();
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return id;
	}

	public long changeGast(Gast gast) {
		if (gast.getId()<0) return -1L;
		try {
			Connection connection = this.connect();
			PreparedStatement statement = connection.prepareStatement(
					"update " + tableName 
					+ " SET name='?', adresse='?', ort='?',"
					+ "email='?', telefon='?') WHERE id=?");
			statement.setString(1, gast.getName());
			statement.setString(2, gast.getAdresse());
			statement.setString(3, gast.getOrt());
			statement.setString(4, gast.getEmail());
			statement.setString(5, gast.getTelefon());
			statement.setLong(6, gast.getId());
			statement.executeUpdate();
			statement.close();
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return gast.getId();
	}

	public Gast getGast(long id) {
		Gast gast = null;
		try {
			Connection connection = this.connect();
			Statement statement = connection.createStatement();
			String select = "SELECT name, adresse, ort, email, telefon" + " FROM " + tableName + " WHERE id=" + id;
			ResultSet ergebnis = statement.executeQuery(select);
			while (ergebnis.next()) {
				gast = new Gast();
				gast.setId(id);
				gast.setName(ergebnis.getString("name"));
				gast.setAdresse(ergebnis.getString("adresse"));
				gast.setOrt(ergebnis.getString("ort"));
				gast.setEmail(ergebnis.getString("email"));
				gast.setTelefon(ergebnis.getString("telefon"));
			}
			ergebnis.close(); // Ergebnismenge schliessen
			statement.close();
		} catch (SQLException e) {
		}
		return gast;
	}
	
	public ArrayList<Gast> getGast(String name) {
		ArrayList<Gast> liste = new ArrayList<>();
		try {
			Connection connection = this.connect();
			Statement statement = connection.createStatement();
			String select = "SELECT id, name, adresse, ort, email, telefon" + " FROM " + tableName;
			if (!name.isEmpty()) {
				select += " WHERE name='" + name + "'";
			}
			ResultSet ergebnis = statement.executeQuery(select);
			while (ergebnis.next()) {
				Gast gast = new Gast();
				gast.setId(ergebnis.getLong("id"));
				gast.setName(ergebnis.getString("name"));
				gast.setAdresse(ergebnis.getString("adresse"));
				gast.setOrt(ergebnis.getString("ort"));
				gast.setEmail(ergebnis.getString("email"));
				gast.setTelefon(ergebnis.getString("telefon"));
				liste.add(gast);
			}
			ergebnis.close(); // Ergebnismenge schliessen
			statement.close();
		} catch (SQLException e) {
		}
		return liste;
	}

	public boolean deleteGast(long id) {
		boolean ok = false;
		try {
			Connection connection = this.connect();
			PreparedStatement statement = connection.prepareStatement("delete from " + tableName + " where id=?");
			statement.setLong(1, id);
			statement.executeUpdate();
			statement.close();
			ok = id>0;
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return ok;
	}
}
