import java.sql.Date;
import java.util.List;

import javax.ws.rs.client.Client;
import javax.ws.rs.client.ClientBuilder;
import javax.ws.rs.client.Entity;
import javax.ws.rs.client.WebTarget;
import javax.ws.rs.core.GenericType;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.UriBuilder;

import org.glassfish.jersey.client.ClientConfig;

public class RestBuchClient {
    static final String HOST = "http://localhost:8080";
    static final String SERVICE = "HeidiRest";
    static final String BUCHAPP = "buch";
    static final String GASTAPP = "mieten";
    static final String BUCHSRV = "buchung";
    static final String GASTSRV = "gast";

    static private List<Buchung> getAllBuchung(WebTarget target) {
    	String server = BUCHSRV+"/all";
    	List<Buchung> antwort = target.path(BUCHAPP).path(server)
    			.request().accept(MediaType.APPLICATION_XML)
    			.get(new GenericType<List<Buchung>>() {});
    	return antwort;
    }

    static private long putXmlGast(WebTarget target, Gast gast) {
    	Response response = target.path(GASTAPP).path(GASTSRV)
                .request(MediaType.APPLICATION_XML)
                .put(Entity.entity(gast, MediaType.APPLICATION_XML));
    	Gast neugast = response.readEntity(Gast.class);
    	return neugast.getId();
    }

    static private long putXmlBuch(WebTarget target, Buchung buchung) {
    	Response response = target.path(BUCHAPP).path(BUCHSRV)
                .request(MediaType.APPLICATION_XML)
                .put(Entity.entity(buchung, MediaType.APPLICATION_XML));
    	Buchung buch = response.readEntity(Buchung.class);
    	return buch.getId();
    }

    public static void main(String[] args) {
        ClientConfig config = new ClientConfig();
        Client client = ClientBuilder.newClient(config);
        WebTarget target = client.target(
        		UriBuilder.fromUri(HOST+"/"+SERVICE).build());

        // Erzeuge Element
        Gast gast = new Gast();
        gast.setName("Jersey Gast");
        gast.setEmail("gast@gast.edu");
        long gastid = putXmlGast(target, gast);

        Buchung buchung = new Buchung();
        buchung.setGastid(gastid);
        buchung.setVon(Date.valueOf("2017-08-12"));
        buchung.setBis(Date.valueOf("2017-08-19"));
        buchung.setWohnung("Grunzer Alm DG");
        System.out.println(buchung);
        long buchstatus = putXmlBuch(target, buchung);
        System.out.println("Status post: "+buchstatus);
        
		List<Buchung> antwort = getAllBuchung(target);
		for (Buchung buch : antwort) {
			System.out.println(buch);
		}
    }
}
