
import java.util.List;

import javax.ws.rs.client.Client;
import javax.ws.rs.client.ClientBuilder;
import javax.ws.rs.client.Entity;
import javax.ws.rs.client.WebTarget;
import javax.ws.rs.core.GenericType;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.UriBuilder;

import org.glassfish.jersey.client.ClientConfig;

public class RestClientJersey {
    static final String HOST = "http://localhost:8080";
    static final String SERVICE = "HeidiRest";
    static final String APPLICATION = "mieten";
    static final String SERVER = "gast";

    static private Gast getOneXml(WebTarget target, long id) {
    	String server = SERVER + "/id/" + id;
    	System.out.println(server);
    	Gast antwort = target.path(APPLICATION).path(server)
    			.request().accept(MediaType.APPLICATION_XML)
    			.get(Gast.class);
    	return antwort;
    }
    
    static private List<Gast> getSomeXml(WebTarget target, String name) {
    	String server = SERVER;
    	if (!name.isEmpty()) {
    		server += "/name/"+name;
    	}
    	System.out.println(server);
    	List<Gast> antwort = target.path(APPLICATION).path(server)
    			.request().accept(MediaType.APPLICATION_XML)
    			.get(new GenericType<List<Gast>>() {});
    	return antwort;
    }

    static private List<Gast> getAllXml(WebTarget target) {
    	List<Gast> antwort = target.path(APPLICATION).path(SERVER+"/all")
    			.request().accept(MediaType.APPLICATION_XML)
    			.get(new GenericType<List<Gast>>() {});
    	return antwort;
    }
    
    static private long putXml(WebTarget target, Gast gast) {
    	Response response = target.path(APPLICATION).path(SERVER)
                .request(MediaType.APPLICATION_XML)
                .put(Entity.entity(gast, MediaType.APPLICATION_XML),
                Response.class);
    	return response.getStatus();
    }
    
    static private long delXml(WebTarget target, long id) {
    	String server = SERVER+"/id/"+id;
    	Response response = target.path(APPLICATION).path(server)
                .request(MediaType.APPLICATION_XML)
                .delete(
                Response.class);
    	return response.getStatus();
    }
    public static void main(String[] args) {
        ClientConfig config = new ClientConfig();
        Client client = ClientBuilder.newClient(config);
        WebTarget target = client.target(
        		UriBuilder.fromUri(HOST+"/"+SERVICE).build());

        // Erzeuge Element
        Gast neugast = new Gast();
        neugast.setName("Jersey Client");
        neugast.setOrt("Jersey Ort");
        long status = putXml(target, neugast);
        System.out.println("Status post: "+status);

        Gast einer = getOneXml(target, 2);
       	System.out.println(einer.getEmail());
        
        List<Gast> einige = getSomeXml(target, "Arnold");
        System.out.println("some");
        for (Gast gast : einige) {
        	System.out.println(gast.getEmail());
        }
        
        delXml(target, 24);
		List<Gast> antwort = getAllXml(target);
		for (Gast gast : antwort) {
			System.out.println(gast.getName());
		}
    }
}
